'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = createReservation;
function createReservation() {
    var fixture = init();

    function init() {
        return {
            id: 'reservationId',
            externalIds: {},
            created: Date.now(),
            modified: Date.now(),
            restaurantId: 'restaurantId',
            distributorId: 'distributorId',
            timeGuarantee: 'about',
            time: Date.now() + 1000 * 60 * 60 * 24, // 24 hours from now
            heldUntil: Date.now() + 1000 * 60 * 60 * 24 + 1000 * 60 * 30, // half an hour later
            contact: {
                firstName: 'First',
                lastName: 'Last',
                email: 'first@last.com',
                phone: '+972501112221'
            },
            partySize: 5,
            comment: 'This is a special request',
            locale: 'he_IL',
            ownerToken: 'ownerToken',
            shareToken: 'shareToken',
            status: 'new',
            restaurantStatus: 'new',
            customerStatus: 'new',
            user: { idIsInferred: null },
            developer: 'com.wix.restaurants',
            source: '',
            platform: 'web',
            log: [{
                type: 'status',
                timestamp: 2,
                user: {},
                actingAs: 'customer',
                properties: {},
                status: 'new'
            }],
            properties: {}
        };
    }

    return {
        id: function id(_id) {
            fixture.id = _id;
            return this;
        },
        externalIds: function externalIds(_externalIds) {
            fixture.externalIds = _externalIds;
            return this;
        },
        created: function created(_created) {
            fixture.created = _created;
            return this;
        },
        modified: function modified(_modified) {
            fixture.modified = _modified;
            return this;
        },
        restaurantId: function restaurantId(_restaurantId) {
            fixture.restaurantId = _restaurantId;
            return this;
        },
        distributorId: function distributorId(_distributorId) {
            fixture.distributorId = _distributorId;
            return this;
        },
        timeGuarantee: function timeGuarantee(_timeGuarantee) {
            fixture.timeGuarantee = _timeGuarantee;
            return this;
        },
        time: function time(_time) {
            fixture.time = _time;
            return this;
        },
        heldUntil: function heldUntil(_heldUntil) {
            fixture.heldUntil = _heldUntil;
            return this;
        },
        contact: function contact(_contact) {
            fixture.contact = _contact;
            return this;
        },
        partySize: function partySize(_partySize) {
            fixture.partySize = _partySize;
            return this;
        },
        comment: function comment(_comment) {
            fixture.comment = _comment;
            return this;
        },
        locale: function locale(_locale) {
            fixture.locale = _locale;
            return this;
        },
        ownerToken: function ownerToken(_ownerToken) {
            fixture.ownerToken = _ownerToken;
            return this;
        },
        shareToken: function shareToken(_shareToken) {
            fixture.shareToken = _shareToken;
            return this;
        },
        status: function status(_status) {
            fixture.status = _status;
            return this;
        },
        restaurantStatus: function restaurantStatus(_restaurantStatus) {
            fixture.restaurantStatus = _restaurantStatus;
            return this;
        },
        customerStatus: function customerStatus(_customerStatus) {
            fixture.customerStatus = _customerStatus;
            return this;
        },
        user: function user(_user) {
            fixture.user = _user;
            return this;
        },
        developer: function developer(_developer) {
            fixture.developer = _developer;
            return this;
        },
        source: function source(_source) {
            fixture.source = _source;
            return this;
        },
        platform: function platform(_platform) {
            fixture.platform = _platform;
            return this;
        },
        log: function log(_log) {
            fixture.log = _log;
            return this;
        },
        properties: function properties(_properties) {
            fixture.properties = _properties;
            return this;
        },
        val: function val() {
            return fixture;
        }
    };
}