'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = {

    /**
     * @return The total price of the item, including all variations.
     */
    getTotalPrice: function getTotalPrice(_ref) {
        var _this = this;

        var orderItem = _ref.orderItem;

        var price = orderItem.price;
        if (!price) price = 0;

        (orderItem.variationsChoices || []).forEach(function (choices) {
            (choices || []).forEach(function (choice) {
                price += _this.getTotalPrice({ orderItem: choice });
            });
        });

        var count = typeof orderItem.count !== 'undefined' ? orderItem.count : 1;
        return price * count;
    }
};