'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.CommonProtocolDriver = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _http = require('http');

var _http2 = _interopRequireDefault(_http);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CommonProtocolDriver = exports.CommonProtocolDriver = function () {
    function CommonProtocolDriver(_ref) {
        var port = _ref.port;

        _classCallCheck(this, CommonProtocolDriver);

        this._server = _http2.default.createServer(this._handler.bind(this));
        this._port = port;
        this.reset();
    }

    _createClass(CommonProtocolDriver, [{
        key: 'start',
        value: function start() {
            this._server.listen(this._port, '127.0.0.1');
        }
    }, {
        key: 'stop',
        value: function stop() {
            this._server.close();
        }
    }, {
        key: 'reset',
        value: function reset() {
            this._rules = [];
        }
    }, {
        key: 'addRule',
        value: function addRule(_ref2) {
            var request = _ref2.request,
                response = _ref2.response,
                _ref2$delay = _ref2.delay,
                delay = _ref2$delay === undefined ? 0 : _ref2$delay,
                _ref2$useRawResponse = _ref2.useRawResponse,
                useRawResponse = _ref2$useRawResponse === undefined ? false : _ref2$useRawResponse;

            this._rules = this._rules || [];
            this._rules.push({ request: request, response: response, delay: delay, useRawResponse: useRawResponse });
        }
    }, {
        key: '_handler',
        value: function _handler(req, res) {
            var _this = this;

            var body = '';
            req.on('data', function (data) {
                body += data;
            });
            req.on('end', function () {
                var request = JSON.parse(body);
                var rule = _lodash2.default.find(_this._rules, function (rule) {
                    if (typeof rule.request === 'function') {
                        return rule.request(request);
                    }
                    return _lodash2.default.isEqual(rule.request, request);
                });

                if (rule) {
                    _lodash2.default.delay(function () {
                        res.writeHead(200, { 'Content-Type': rule.useRawResponse ? 'text/html' : 'application/json' });

                        var response = rule.response;

                        if (typeof response === 'function') {
                            response = response(request);
                        }

                        res.end(rule.useRawResponse ? response : JSON.stringify(response));
                    }, rule.delay);
                } else {
                    res.writeHead(404);
                    res.end();
                }
            });
        }
    }]);

    return CommonProtocolDriver;
}();