'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _nock = require('nock');

var _nock2 = _interopRequireDefault(_nock);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NockProtocolDriver = function () {
    function NockProtocolDriver(_ref) {
        var url = _ref.url,
            version = _ref.version;

        _classCallCheck(this, NockProtocolDriver);

        this.url = url || 'https://api.wixrestaurants.com';
        this.version = version || 'v1.1';
    }

    _createClass(NockProtocolDriver, [{
        key: 'start',
        value: function start() {}
    }, {
        key: 'reset',
        value: function reset() {
            _nock2.default.cleanAll();
        }
    }, {
        key: 'stop',
        value: function stop() {
            _nock2.default.cleanAll();
        }
    }, {
        key: 'addRule',
        value: function addRule(_ref2) {
            var request = _ref2.request,
                delay = _ref2.delay,
                response = _ref2.response;


            var shouldHandle = function shouldHandle(body) {
                if (typeof request === 'function') {
                    return request(body);
                } else {
                    return _lodash2.default.isEqual(request, body);
                }
            };

            var respond = function respond(body) {
                if (typeof response === 'function') {
                    return response(body);
                } else {
                    return [200, response];
                }
            };

            (0, _nock2.default)(this.url).post('/' + this.version).delayConnection(delay || 0).times(-1).reply(function (uri, body) {
                if (shouldHandle(body)) {
                    return respond(body);
                }
            });
        }
    }]);

    return NockProtocolDriver;
}();

exports.default = NockProtocolDriver;