'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _CommonProtocolDriver = require('./CommonProtocolDriver');

var _NockProtocolDriver = require('./NockProtocolDriver');

var _NockProtocolDriver2 = _interopRequireDefault(_NockProtocolDriver);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var OpenrestDriver = function () {

    /**
     * Type can be:
     *      'common' uses a network mock. the params should include [port].
     *      'nock' users nock. the params should include [url].
     */
    function OpenrestDriver(_ref) {
        var type = _ref.type,
            params = _ref.params;

        _classCallCheck(this, OpenrestDriver);

        var drivers = {
            'localNetwork': _CommonProtocolDriver.CommonProtocolDriver,
            'nock': _NockProtocolDriver2.default
        };

        this._driver = new drivers[type](params);
    }

    _createClass(OpenrestDriver, [{
        key: 'start',
        value: function start() {
            this._driver.start();
        }
    }, {
        key: 'stop',
        value: function stop() {
            this._driver.stop();
        }
    }, {
        key: 'reset',
        value: function reset() {
            this._driver.reset();
        }
    }, {
        key: 'requestFor',
        value: function requestFor(_ref2) {
            var _this2 = this;

            var request = _ref2.request;


            var params = {
                resource: '/',
                request: request
            };

            var _this = {
                delayBy: function delayBy(_ref3) {
                    var ms = _ref3.ms;

                    params.delay = ms;
                    return _this;
                },

                succeedWith: function succeedWith(_ref4) {
                    var response = _ref4.response;

                    params.response = response;

                    _this2._driver.addRule(params);
                },

                failWith: function failWith(_ref5) {
                    var code = _ref5.code,
                        description = _ref5.description;

                    params.response = { error: code, errorMessage: description };
                    params.error = true;

                    _this2._driver.addRule(params);
                },

                failWithProtocolError: function failWithProtocolError() {
                    params.response = '<html></html>';
                    params.useRawResponse = true;

                    _this2._driver.addRule(params);
                }
            };

            return _this;
        }
    }]);

    return OpenrestDriver;
}();

exports.default = OpenrestDriver;